// AlphaScriptHost.cpp
// (c) 2003-2004 exeal

#include "StdAfx.h"
#include "AlphaScriptHost.h"
#include <objsafe.h>	// IObjectSafety
using Alpha::CAlphaScriptHost;
using Alpha::ScriptSiteSecurityLevel;
using Alpha::CEnumImpl;
using namespace std;
using namespace Armaiti;


// ɂĂ͊ CLSID AIID `ɂȂ
// ȉ̐錾IIɗLɂƂ悢 (Ǝv)

// static const CLSID CLSID_ProcessDebugManager = {
//		0x78a51822, 0x51f4, 0x11d0, {0x8f, 0x20, 0x00, 0x80, 0x5f, 0x2c, 0xd0, 0x64}};
static const IID	IID_IActiveScriptDebug = {
	0x51973C10, 0xCB0C, 0x11d0, {0xB5, 0xC9, 0x00, 0xA0, 0x24, 0x4A, 0x0E, 0x7A}};
static const IID	IID_IActiveScriptSiteDebug = {
	0x51973C11, 0xCB0C, 0x11d0, {0xB5, 0xC9, 0x00, 0xA0, 0x24, 0x4A, 0x0E, 0x7A}};
static const IID	IID_IProcessDebugManager = {
	0x51973C2f, 0xCB0C, 0x11d0, {0xB5, 0xC9, 0x00, 0xA0, 0x24, 0x4A, 0x0E, 0x7A}};
static const IID	IID_IDebugApplication = {
	0x51973C32, 0xCB0C, 0x11d0, {0xB5, 0xC9, 0x00, 0xA0, 0x24, 0x4A, 0x0E, 0x7A}};

namespace {
	///	CxgVNIuWFNg쐬̂ɕKvȏ
	struct TConnectionInfo {
		///	XNvgzXg
		CAlphaScriptHost*	pScriptHost;
		///	ڑ/sƂ̃Cxg
		HANDLE				hConnectionCompletionEvent;
		///	ڑ̌
		HRESULT				hr;
		///	ڑ|Cg
		IStream*			pConnectionPoint;
		///	CxgVN IID
		IID					iidEvent;
		///	bZ[Wnh̐ړ
		wstring				strPrefix;
	};
}


// CAlphaScriptHost class implementation
/////////////////////////////////////////////////////////////////////////////

const wchar_t* 			CAlphaScriptHost::m_pwszName = L"Alpha Script Host";
const unsigned short	CAlphaScriptHost::m_nMajorVersion = 0;	///	W[o[W
const unsigned short	CAlphaScriptHost::m_nMinorVersion = 6;	///	}Ci[o[W
const unsigned short	CAlphaScriptHost::m_nBuildVersion = 1;	///	rhԍ

/**
 *	RXgN^
 *	@param hWnd							TCgEBhE
 *	@param pScriptEngine				GW
 *	@param bIgnoreCaseOnPropertySearch	vpeBTɑ啶ʂȂ
 */
CAlphaScriptHost::CAlphaScriptHost(HWND hWnd, IActiveScript* pScriptEngine, bool bIgnoreCaseOnPropertySearch)
		: m_hOwnerWindow(hWnd), m_pScriptEngine(pScriptEngine),
		m_nSecurityLevelForSafeObject(SSSL_ALLOW), m_nSecurityLevelForUnsafeObject(SSSL_QUERYUSER),
		m_bAllowedErrorReport(true), m_bIgnoreCase(bIgnoreCaseOnPropertySearch),
		m_bEnteredScript(false), m_bInteractive(true), m_nTimeout(0) {
	assert(m_hOwnerWindow == 0 || ::IsWindow(m_hOwnerWindow));
	assert(m_pScriptEngine != 0);

	wcscpy(m_wszScriptPath, L"");
//	m_pScriptEngine->AddRef();

	// GWɎZLeB}l[WƂĎg킹
	CComPtr<IObjectSafety>	pObjectSafety;
	if(SUCCEEDED(m_pScriptEngine->QueryInterface(IID_IObjectSafety, reinterpret_cast<void**>(&pObjectSafety)))) {
		DWORD	dwSupportedOpts, dwEnabledOpts;
		if(SUCCEEDED(pObjectSafety->GetInterfaceSafetyOptions(
				IID_NULL, &dwSupportedOpts, &dwEnabledOpts))) {
			pObjectSafety->SetInterfaceSafetyOptions(
				IID_NULL, dwSupportedOpts, INTERFACE_USES_SECURITY_MANAGER);
		}
	}
}

///	fXgN^
CAlphaScriptHost::~CAlphaScriptHost() {
//	m_pScriptEngine->Release();
	ReleaseTopLevelObjects(true);
	for(map<IDispatch*, HANDLE>::iterator it
			= m_mapEventSinkThreads.begin(); it != m_mapEventSinkThreads.end(); ++it) {
		it->first->Release();
		::CloseHandle(it->second);
	}
}

/**
 *	ŏʃIuWFNg̐ݒBOŕ̃IuWFNgǉꍇ̋ɂĂ͕ۏ؂ȂB
 *	̃IuWFNg͎ʎq̑啶ʂȂB
 *	@param pwszObjectName	ŏʃIuWFNg̖O
 *	@param pObject			ŏʃIuWFNg
 *	@param dwItemTraits		IActiveScript::AddNamedItem Ɠ
 */
void CAlphaScriptHost::AddTopLevelObject(const OLECHAR* pwszObjectName, IDispatch* pObject, DWORD dwItemTraits) {
	assert(pwszObjectName != 0);
	assert(pObject != 0);

	if(m_bEnteredScript) {
		wchar_t*	pwsz = const_cast<wchar_t*>(pwszObjectName);
		if(m_bIgnoreCase) {
			pwsz = new wchar_t[wcslen(pwszObjectName) + 1];
			wcscpy(pwsz, pwszObjectName);
			::CharLowerW(pwsz);
		}
		m_mapTopLevelObjects[pwsz] = pObject;
		pObject->AddRef();
		m_pScriptEngine->AddNamedItem(pwszObjectName, dwItemTraits);
		if(m_bIgnoreCase)
			delete[] pwsz;
	} else {	// XNvg̎sJnĂȂꍇ
		TTopLevelObject*	p = new TTopLevelObject;
		p->strObjectName = pwszObjectName;
		p->pObject = pObject;
		p->dwItemTraits = dwItemTraits;
		p->pObject->AddRef();
		m_stkWaitingObjects.push(p);
	}
}

/**
 *
 *	@param pObject		ڑmIuWFNg
 *	@param pwszPrefix	Cxgnh̐ړ
 *	@return				SCODE
 */
HRESULT CAlphaScriptHost::ConnectObject(IDispatch* pObject, const OLECHAR* pwszPrefix) {
	assert(pObject != 0 && pwszPrefix != 0);

	HRESULT								hr;
	CComPtr<IConnectionPointContainer>	pCPContainer;
	CComPtr<IEnumConnectionPoints>		pCPEnumerator;
	CComPtr<IConnectionPoint>			pConnectionPoint;
	CComPtr<IProvideClassInfo2>			pClassInfoProvider;
	IID									iidEvent;

	// ڑ|CgT
	if(FAILED(pObject->QueryInterface(IID_IConnectionPointContainer, reinterpret_cast<void**>(&pCPContainer))))
		return E_NOINTERFACE;
	if(S_OK == pObject->QueryInterface(
			IID_IProvideClassInfo2, reinterpret_cast<void**>(&pClassInfoProvider))) {
		// IProvideClassInfo2::GetGUID Ŏ擾łꍇ
		if(FAILED(hr = pClassInfoProvider->GetGUID(GUIDKIND_DEFAULT_SOURCE_DISP_IID, &iidEvent)))
			return hr;
		if(FAILED(hr = pCPContainer->FindConnectionPoint(iidEvent, &pConnectionPoint)))
			return hr;
	} else if(SUCCEEDED(hr = pCPContainer->EnumConnectionPoints(&pCPEnumerator))) {
		// SẴCxgɑΉ
		if(S_OK == pCPEnumerator->Next(1, &pConnectionPoint, 0)) {
			if(FAILED(hr = pConnectionPoint->GetConnectionInterface(&iidEvent)))
				return hr;
		}
	}
	if(pConnectionPoint == 0)
		return E_FAIL/*CONNECT_E_CANNOTCONNECT*/;

	// XbhĂ̒ɃCxgVNIuWFNg쐬
	CComPtr<IDispatch>	pTopLevel;
	TConnectionInfo		connection;
	unsigned int		nThreadId;
	HANDLE				hThread;

	connection.pScriptHost = this;
	connection.hConnectionCompletionEvent = ::CreateEvent(0, true, false, 0);
	::CoMarshalInterThreadInterfaceInStream(
		IID_IConnectionPoint, pConnectionPoint, &connection.pConnectionPoint);
	connection.iidEvent = iidEvent;
	connection.strPrefix = pwszPrefix;
	hThread = reinterpret_cast<HANDLE>(::_beginthreadex(0, 0,
		CAlphaScriptHost::EventSinkThreadProc, &connection, 0, &nThreadId));

	if(hThread == 0) {	// Xbh쐬s
		::CloseHandle(connection.hConnectionCompletionEvent);
		connection.pConnectionPoint->Release();
		return E_FAIL;
	}
	::WaitForSingleObject(connection.hConnectionCompletionEvent, INFINITE);
	::ResetEvent(connection.hConnectionCompletionEvent);
	if(SUCCEEDED(connection.hr)) {
		m_mapEventSinkThreads[pObject] = hThread;
		pObject->AddRef();
	}
	return connection.hr;
}

/**
 *	
 *	@param pObject	ڑIuWFNg
 *	@return			SCODE
 */
HRESULT CAlphaScriptHost::DisconnectObject(IDispatch* pObject) {
	assert(pObject != 0);
	
	map<IDispatch*, HANDLE>::iterator	it = m_mapEventSinkThreads.find(pObject);

	if(it == m_mapEventSinkThreads.end())
		return E_INVALIDARG;
	::TerminateThread(it->second, 0);
	it->first->Release();
	::CloseHandle(it->second);
	m_mapEventSinkThreads.erase(it);
	return S_OK;
}

unsigned int __stdcall CAlphaScriptHost::EventSinkThreadProc(void* p) {
	TConnectionInfo*			pConnection = static_cast<TConnectionInfo*>(p);
	CComPtr<IConnectionPoint>	pConnectionPoint;
	CComPtr<IActiveScript>		pScriptEngine;
	CComPtr<CAdhocEventSink>	pEventSink;

	::CoInitializeEx(0, COINIT_MULTITHREADED);	// MTA ɓ

	// A}[VO
	::CoGetInterfaceAndReleaseStream(pConnection->pConnectionPoint,
		IID_IConnectionPoint, reinterpret_cast<void**>(&pConnectionPoint));

	pEventSink = new CAdhocEventSink(pConnection->iidEvent, pConnection->pScriptHost, pConnection->strPrefix);
	pConnection->hr = pEventSink->Connect(pConnectionPoint);

	::SetEvent(pConnection->hConnectionCompletionEvent);
	if(FAILED(pConnection->hr)) {
		::_endthreadex(0);
		::CoUninitialize();
		return 0;
	}

	MSG	message;
	::PeekMessage(&message, 0, 0, 0, PM_NOREMOVE);
	while(::GetMessage(&message, 0, 0, 0) > 0)
		::DispatchMessage(&message);

	::CoUninitialize();
	return 0;
}

/**
 *	XNvg猾GW肵A CLSID Ԃ
 *	@param pwszFileName	XNvg
 *	@param clsid		[out] GW CLSIDBɎsꍇ CLSID_NULL
 */
void CAlphaScriptHost::FindScriptEngine(const wchar_t* pwszFileName, CLSID& clsid) {
	assert(pwszFileName != 0);
	clsid = CLSID_NULL;

	wchar_t*	pwszExt = ::PathFindExtensionW(pwszFileName);
	HKEY		hKey;
	wchar_t		wszFileType[100], wszProgId[100], wszScriptEngine[100];
	DWORD		cbData;
	long		err;

	if(*pwszExt == 0)
		return;
	if(ERROR_SUCCESS != ::RegOpenKeyExW(HKEY_CLASSES_ROOT, pwszExt, 0, KEY_READ, &hKey))
		return;
	cbData = sizeof(wszFileType);
	err = ::RegQueryValueExW(hKey, 0, 0, 0, reinterpret_cast<BYTE*>(wszFileType), &cbData);
	::RegCloseKey(hKey);
	if(err != ERROR_SUCCESS)
		return;

	wcscpy(wszScriptEngine, wszFileType);
	wcscat(wszScriptEngine, L"\\ScriptEngine");
	err = ::RegOpenKeyExW(HKEY_CLASSES_ROOT, wszScriptEngine, 0, KEY_READ, &hKey);
	cbData = sizeof(wszProgId);
	if(err == ERROR_SUCCESS) {
		err = ::RegQueryValueExW(hKey, 0, 0, 0, reinterpret_cast<BYTE*>(wszProgId), &cbData);
		::RegCloseKey(hKey);
	} else {
		::RegCloseKey(hKey);
		// L[ "ScriptFile" tčĒ (PerlScript Ƃ)
		wcscpy(wszScriptEngine, wszFileType);
		wcscat(wszScriptEngine, L"ScriptFile\\ScriptEngine");
		if(ERROR_SUCCESS != ::RegOpenKeyExW(HKEY_CLASSES_ROOT, wszScriptEngine, 0, KEY_READ, &hKey))
			return;
		err = ::RegQueryValueExW(hKey, 0, 0, 0, reinterpret_cast<BYTE*>(wszProgId), &cbData);
		::RegCloseKey(hKey);
		if(err != ERROR_SUCCESS)
			return;
	}
	::CLSIDFromProgID(wszProgId, &clsid);
}

///	@see	IActiveScriptSite::GetItemInfo
STDMETHODIMP CAlphaScriptHost::GetItemInfo(LPCOLESTR pstrName,
		DWORD dwReturnMask, IUnknown** ppunkItem, ITypeInfo** ppTypeInfo) {
	IDispatch*					pItemObject = 0;
	wchar_t*					pwsz = const_cast<OLECHAR*>(pstrName);
	MemberTable::const_iterator	it;

	if(m_bIgnoreCase) {
		pwsz = new wchar_t[wcslen(pstrName) + 1];
		wcscpy(pwsz, pstrName);
		::CharLowerW(pwsz);
	}
	it = m_mapTopLevelObjects.find(pwsz);

	if(it != m_mapTopLevelObjects.end())
		pItemObject = it->second;
	else {
		if(dwReturnMask & SCRIPTINFO_IUNKNOWN) {
			VERIFY_POINTER(ppunkItem);
			*ppunkItem = 0;
		}
		if(dwReturnMask & SCRIPTINFO_ITYPEINFO) {
			VERIFY_POINTER(ppTypeInfo);
			*ppTypeInfo = 0;
		}
		if(m_bIgnoreCase)
			delete[] pwsz;
		return TYPE_E_ELEMENTNOTFOUND;
	}

	if(dwReturnMask & SCRIPTINFO_IUNKNOWN) {
		VERIFY_POINTER(ppunkItem);
		*ppunkItem = pItemObject;
		(*ppunkItem)->AddRef();
	}
	if(dwReturnMask & SCRIPTINFO_ITYPEINFO) {
		VERIFY_POINTER(ppTypeInfo);
		pItemObject->GetTypeInfo(0, 0, ppTypeInfo);
	}

	if(m_bIgnoreCase)
		delete[] pwsz;
	return S_OK;
}

/**
 *	XNvg̔Cӂ̃vVWĂяo
 *	@param pwszName	vVW
 *	@param lcid		ĂяoP[
 *	@param pParams		
 */
HRESULT CAlphaScriptHost::InvokeScriptGlobalProcedure(const OLECHAR* pwszName, LCID lcid, DISPPARAMS* pParams) {
	if(pwszName == 0 || pParams == 0)
		return E_INVALIDARG;
	if(m_pScriptEngine == 0)
		return E_UNEXPECTED;

	CComPtr<IActiveScript>	pClonedEngine;
	CComPtr<IDispatch>		pTopLevel;
	DISPID					id;
	HRESULT					hr;

	if(FAILED(hr = m_pScriptEngine->GetScriptDispatch(0, &pTopLevel)))
		return hr;
	if(FAILED(hr = pTopLevel->GetIDsOfNames(IID_NULL, const_cast<OLECHAR**>(&pwszName), 1, lcid, &id)))
		return hr;

	VARIANT			varResult;
	EXCEPINFO		exception;
	unsigned int	iArgErr;

	::VariantInit(&varResult);
	hr = pTopLevel->Invoke(id, IID_NULL, lcid, DISPATCH_METHOD, pParams, &varResult, &exception, &iArgErr);
	::VariantClear(&varResult);
	return hr;
}

///	@see	IActiveScriptSite::OnEnterScript
STDMETHODIMP CAlphaScriptHost::OnEnterScript() {
//	if(m_pDebugApplication != 0)
//		HRESULT	hr = m_pDebugApplication->CauseBreak();	// fobKu[N|CgZbg邽߂Ɏ~߂
	m_bEnteredScript = true;
	while(!m_stkWaitingObjects.empty()) {
		TTopLevelObject*	p = m_stkWaitingObjects.top();
		wchar_t*			pwsz = const_cast<wchar_t*>(p->strObjectName.c_str());

		if(m_bIgnoreCase) {
			pwsz = new wchar_t[p->strObjectName.length() + 1];
			wcscpy(pwsz, p->strObjectName.c_str());
			::CharLowerW(pwsz);
		}
		m_mapTopLevelObjects[pwsz] = p->pObject;
		m_pScriptEngine->AddNamedItem(p->strObjectName.c_str(), p->dwItemTraits);
		delete p;
		m_stkWaitingObjects.pop();
		if(m_bIgnoreCase)
			delete[] pwsz;
	}
	return S_OK;
}

///	@see	IActiveScriptSite::OnScriptError
STDMETHODIMP CAlphaScriptHost::OnScriptError(IActiveScriptError* pscripterror) {
	if(pscripterror == 0)
		return E_INVALIDARG;

	EXCEPINFO	ei;

	pscripterror->GetExceptionInfo(&ei);
	if(ei.scode == S_OK)	// G[ł͂Ȃ
		return S_OK;

	DWORD			dwSrcCtx;
	unsigned long	iLine;
	long			iChar;

	m_bIsErrorReported = true;

	// G[bZ[Wo
	if(m_bAllowedErrorReport) {
		wostringstream	ss;

		pscripterror->GetSourcePosition(&dwSrcCtx, &iLine, &iChar);
		if(::GetUserDefaultLangID() == 0x0411) {
			ss << L"XNvgG[܂B"
				<< L"\n\nXNvg:\t" << ((m_wszScriptPath[0] != 0) ? m_wszScriptPath : L"(s)")
				<< L"\ns:\t" << iLine + 1
				<< L"\n:\t" << iChar + 1
				<< L"\nG[:\t" << ((ei.bstrDescription != 0) ? ei.bstrDescription : L"(s)")
				<< L"\nSCODE:\t" << hex << uppercase << ei.scode
				<< L"\nG[:\t" << ((ei.bstrSource != 0) ? ei.bstrSource : L"(s)");
		} else {
			ss << L"Script error occured."
				<< L"\n\nscript:\t" <<  ((m_wszScriptPath[0] != 0) ? m_wszScriptPath : L"(unknown)")
				<< L"\nline:\t" << iLine + 1
				<< L"\ncharacter:\t" << iChar + 1
				<< L"\nerror:\t" << ((ei.bstrDescription != 0) ? ei.bstrDescription : L"(unknown)")
				<< L"\nscode:\t" << hex << uppercase << ei.scode
				<< L"\nsource:\t" << ((ei.bstrSource != 0) ? ei.bstrSource : L"(unknown)");
		}
		::MessageBoxW(m_hOwnerWindow, ss.str().c_str(), m_pwszName, MB_ICONHAND);
		::SysFreeString(ei.bstrSource);
		::SysFreeString(ei.bstrDescription);
		::SysFreeString(ei.bstrHelpFile);
	}

	return S_OK;
}

///	@see	IInternetHostSecurityManager::ProcessUrlAction
STDMETHODIMP CAlphaScriptHost::ProcessUrlAction(DWORD dwAction,
		BYTE* pPolicy, DWORD cbPolicy, BYTE* pContext, DWORD cbContext, DWORD dwFlags, DWORD dwReserved) {
	VERIFY_POINTER(pPolicy);
	if(cbPolicy < sizeof(DWORD) || dwReserved != 0)
		return (pPolicy = 0), E_INVALIDARG;

	// ActiveX IuWFNg쐬ȊO̍sׂ͑SċB
	// ASR ̓XNvgsO URLACTION_JAVA_CURR_MAX nĂ邪A
	// URLPOLICY_ALLOW ԂĂ΃ZLeBxŒɂȂA
	// łȏԂɂȂ悤 (2004/3)
	if(dwAction != URLACTION_ACTIVEX_RUN) {
		*pPolicy = URLPOLICY_ALLOW;
		return S_OK;
	}

	ScriptSiteSecurityLevel	nSecurityLevel = m_nSecurityLevelForUnsafeObject;
	CComPtr<ICatInformation>	pci;

	// KpZLeBx肷̂Ɏ\ɂIuWFNgSǂ𒲂ׂB
	// R|[lgJeS "Controls that are safely scripable" g
	if(cbContext == sizeof(CLSID)
			&& SUCCEEDED(::CoCreateInstance(CLSID_StdComponentCategoriesMgr,
			0, CLSCTX_ALL, IID_ICatInformation, reinterpret_cast<void**>(&pci)))) {
		CATID	id = CATID_SafeForScripting;
		if(S_OK == pci->IsClassOfCategories(*reinterpret_cast<CLSID*>(pContext), 1, &id, -1, 0))
			nSecurityLevel = m_nSecurityLevelForSafeObject;
	}

	memset(pPolicy, 0, cbPolicy);

	if(nSecurityLevel <= SSSL_ALLOW) {
		*pPolicy = URLPOLICY_ALLOW;
		return S_OK;
	} else if(nSecurityLevel == SSSL_QUERYUSER
			&& ::IsWindow(m_hOwnerWindow)
			&& !(dwFlags & PUAF_NOUI)) {
		// x_CAOo
		wostringstream	ss;
		UINT		nDialogType = MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2;
		OLECHAR*	pwszProgID = 0;
		OLECHAR*	pwszCLSID = 0;

		if(dwFlags & PUAF_FORCEUI_FOREGROUND)
			nDialogType |= MB_SETFOREGROUND;

		if(cbContext == sizeof(CLSID)) {
			::ProgIDFromCLSID(*reinterpret_cast<CLSID*>(pContext), &pwszProgID);
			::StringFromCLSID(*reinterpret_cast<CLSID*>(pContext), &pwszCLSID);
		}
		if(::GetUserDefaultLangID() == 0x0411)
			ss << m_wszScriptPath
				<< L"\n\nL̃XNvg͈SłȂ\̂IuWFNg쐬悤ƂĂ܂B"
				<< L"\nIuWFNg̍쐬܂?\n\nvꂽIuWFNg:"
				<< L"\n  ProgID:\t" << ((pwszProgID != 0) ? pwszProgID : L"(擾ł܂ł)")
				<< L"\n  IID:\t" << ((pwszCLSID != 0) ? pwszCLSID : L"(擾ł܂ł)");
		else
			ss << m_wszScriptPath
				<< L"\n\nAbove script is about to create the object possibly unsafe."
				<< L"\nDo you allow this?\n\nRequired object is:"
				<< L"\n  ProgID:\t" << ((pwszProgID != 0) ? pwszProgID : L"(failed to obtain)")
				<< L"\n  IID:\t" << ((pwszCLSID != 0) ? pwszCLSID : L"(failed to obtain)");
		*pPolicy = (::MessageBoxW(m_hOwnerWindow, ss.str().c_str(), m_pwszName,
						nDialogType) == IDYES) ? URLPOLICY_ALLOW : URLPOLICY_DISALLOW;

		if(pwszProgID != 0)	::CoTaskMemFree(pwszProgID);
		if(pwszCLSID != 0)	::CoTaskMemFree(pwszCLSID);

		return (*pPolicy == URLPOLICY_ALLOW) ? S_OK : S_FALSE;
	} else /*if(nSecurityLevel >= SSSL_DISALLOW)*/ {
		*pPolicy = URLPOLICY_DISALLOW;
		return S_FALSE;
	}
}

///	@see	IInternetHostSecurityManager::QueryCustomPolicy
STDMETHODIMP CAlphaScriptHost::QueryCustomPolicy(REFGUID guidKey,
		BYTE** ppPolicy, DWORD* pcbPolicy, BYTE* pContext, DWORD cbContext, DWORD dwReserved) {
	VERIFY_POINTER(ppPolicy);
	VERIFY_POINTER(pcbPolicy);

	*ppPolicy = 0;
	*pcbPolicy = 0;
	if(dwReserved != 0)
		return E_INVALIDARG;
//	if(guidKey = GUID_CUSTOM_CONFIRMSAFETY && cbContext >= sizeof(CONFIRMSAFETY*)) {
//		CONFIRMSAFETY*	pcs = reinterpret_cast<CONFIRMSAFETY*>(pContext);
//	}
	*ppPolicy = static_cast<BYTE*>(::CoTaskMemAlloc(sizeof(DWORD)));
	if(*ppPolicy == 0)
		return E_OUTOFMEMORY;
	*pcbPolicy = sizeof(DWORD);
	**ppPolicy = URLPOLICY_ALLOW;
	return S_OK;
}

///	ŏʃIuWFNgSč폜
void CAlphaScriptHost::ReleaseTopLevelObjects(bool bAlsoRegistered) {
	while(!m_stkWaitingObjects.empty()) {
		delete m_stkWaitingObjects.top();
		m_stkWaitingObjects.pop();
	}
	if(bAlsoRegistered) {
		for(MemberTable::iterator it =
				m_mapTopLevelObjects.begin(); it != m_mapTopLevelObjects.end(); ++it)
			it->second->Release();
		m_mapTopLevelObjects.clear();
	}
}

/**
 *	XNvgw莞Ԓ~ (Cxg̃nhO͌p)
 *	@param nMilliseconds	~~b (0ł)
 */
void CAlphaScriptHost::Sleep(unsigned long nMilliseconds) {
	::Sleep(nMilliseconds);
}


// CAdhocEventSink class implementation
/////////////////////////////////////////////////////////////////////////////

/**
 *	RXgN^
 *	@param iidEvent		CxgC^[tFCX IID
 *	@param pTopLevel	XNvg̃gbvxIuWFNg
 *	@param strPrefix	Cxgnh̐ړ
 */
CAlphaScriptHost::CAdhocEventSink::CAdhocEventSink(
		const IID& iidEvent, CAlphaScriptHost* pScriptHost, const wstring& strPrefix)
		: m_pConnectionPointContainer(0), m_iidEvent(iidEvent),
		m_pScriptHost(pScriptHost), m_strPrefix(strPrefix) {
}

///	fXgN^
CAlphaScriptHost::CAdhocEventSink::~CAdhocEventSink() {
	if(m_pConnectionPointContainer != 0)
		m_pConnectionPointContainer->Release();
}

/**
 *	CxgVNƂĐڑ
 *	@param pConnectionPoint	ڑ|Cg
 *	@return					IConnectionPoint::Advise Ɠ
 */
HRESULT CAlphaScriptHost::CAdhocEventSink::Connect(IConnectionPoint* pConnectionPoint) {
	if(pConnectionPoint == 0)
		return E_INVALIDARG;
	if(m_pConnectionPointContainer != 0)
		return E_UNEXPECTED;

	HRESULT	hr;

	if(FAILED(hr = pConnectionPoint->Advise(static_cast<IUnknown*>(this), &m_dwCookie)))
		return hr;
	pConnectionPoint->GetConnectionPointContainer(&m_pConnectionPointContainer);

	// \bh̃G~[g
	// (̓G[NĂ S_OK Ԃ)
	CComPtr<IProvideClassInfo>	pClassInfoProvider;
	CComPtr<ITypeInfo>			pTypeInfo;
	CComPtr<IDispatch>			pActiveXObject;
	if((SUCCEEDED(m_pConnectionPointContainer->QueryInterface(
			IID_IProvideClassInfo, reinterpret_cast<void**>(&pClassInfoProvider)))
			&& SUCCEEDED(pClassInfoProvider->GetClassInfo(&pTypeInfo)))
			|| (SUCCEEDED(m_pConnectionPointContainer->QueryInterface(
			IID_IDispatch, reinterpret_cast<void**>(&pActiveXObject)))
			&& SUCCEEDED(pActiveXObject->GetTypeInfo(0, LOCALE_USER_DEFAULT, &pTypeInfo)))) {
		CComPtr<ITypeLib>	pTypeLib;
		UINT				i;
		if(SUCCEEDED(pTypeInfo->GetContainingTypeLib(&pTypeLib, &i))) {
			pTypeInfo = 0;
			if(SUCCEEDED(pTypeLib->GetTypeInfoOfGuid(m_iidEvent, &pTypeInfo))) {
				TYPEATTR*	pTypeAttribute;
				if(SUCCEEDED(pTypeInfo->GetTypeAttr(&pTypeAttribute))) {
					for(WORD i = 0; i < pTypeAttribute->cFuncs; ++i) {
						FUNCDESC*	pMethodDescription;
						if(SUCCEEDED(pTypeInfo->GetFuncDesc(i, &pMethodDescription))) {
							BSTR	bstrName;
							if(SUCCEEDED(pTypeInfo->GetDocumentation(
									pMethodDescription->memid, &bstrName, 0, 0, 0))) {
								m_mapEvents[bstrName] = pMethodDescription->memid;
								m_mapHandlers[pMethodDescription->memid] = m_strPrefix + bstrName;
								::SysFreeString(bstrName);
							}
							pTypeInfo->ReleaseFuncDesc(pMethodDescription);
						}
					}
					pTypeInfo->ReleaseTypeAttr(pTypeAttribute);
				}
			}
		}
	}

	return S_OK;
}

/**
 *	ڑ
 *	@return	IConnectionPoint::Unadvise Ɠ
 */
HRESULT CAlphaScriptHost::CAdhocEventSink::Disconnect() {
	if(m_pConnectionPointContainer == 0)
		return E_UNEXPECTED;

	HRESULT						hr;
	CComPtr<IConnectionPoint>	pConnectionPoint;

	if(FAILED(hr = m_pConnectionPointContainer->FindConnectionPoint(m_iidEvent, &pConnectionPoint)))
		return hr;
	m_mapEvents.clear();
	m_mapHandlers.clear();
	return pConnectionPoint->Unadvise(m_dwCookie);
}

///	@see	IDispatch::GetIDsOfNames
STDMETHODIMP CAlphaScriptHost::CAdhocEventSink::GetIDsOfNames(
		REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId) {
	if(riid != IID_NULL)
		return E_INVALIDARG;
	VERIFY_POINTER(rgDispId);

	for(unsigned int i = 0; i < cNames; ++i) {
		map<wstring, DISPID>::const_iterator	it = m_mapEvents.find(rgszNames[i]);
		if(it == m_mapEvents.end())
			return DISP_E_UNKNOWNNAME;
		rgDispId[i] = it->second;
	}
	return S_OK;
}

///	@see	IDispatch::GetTypeInfo
STDMETHODIMP CAlphaScriptHost::CAdhocEventSink::GetTypeInfo(UINT iTypeInfo, LCID lcid, ITypeInfo** ppTypeInfo) {
	VERIFY_POINTER(ppTypeInfo);
	*ppTypeInfo = 0;
	return TYPE_E_ELEMENTNOTFOUND;
}

///	@see	IDispatch::GetTypeInfoCount
STDMETHODIMP CAlphaScriptHost::CAdhocEventSink::GetTypeInfoCount(UINT* pcTypeInfo) {
	VERIFY_POINTER(pcTypeInfo);
	*pcTypeInfo = 0;
	return S_OK;
}

///	@see	IDispatch::Invoke
STDMETHODIMP CAlphaScriptHost::CAdhocEventSink::Invoke(DISPID dispidMember,
		REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams,
		VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int* puArgErr) {
	if(riid != IID_NULL)
		return E_INVALIDARG;

	map<DISPID, wstring>::const_iterator	it = m_mapHandlers.find(dispidMember);

	if(it == m_mapHandlers.end())
		return DISP_E_MEMBERNOTFOUND;

	OLECHAR*	pwszName = const_cast<OLECHAR*>(it->second.c_str());
	return m_pScriptHost->InvokeScriptGlobalProcedure(pwszName, lcid, pDispParams);
}

///	@see	IUnknown::QueryInterface
STDMETHODIMP CAlphaScriptHost::CAdhocEventSink::QueryInterface(REFIID riid, void** ppvObject) {
	VERIFY_POINTER(ppvObject);

	if(riid == m_iidEvent || riid == IID_IDispatch || riid == IID_IUnknown)
		*ppvObject = static_cast<IDispatch*>(this);
	else
		return (*ppvObject = 0), E_NOINTERFACE;
	reinterpret_cast<IUnknown*>(*ppvObject)->AddRef();
	return S_OK;
}


// CEnumImpl class implementation
/////////////////////////////////////////////////////////////////////////////

/**
 *	RXgN^
 *	@param bIgnoreCaseOnPropertySearch	vpeBTɑ啶ʂ邩
 */
CEnumImpl::CEnumImpl(bool bIgnoreCaseOnPropertySearch) : m_bIgnoreCase(bIgnoreCaseOnPropertySearch) {
}

/**
 *	vpeBǉ
 *	@param pwszName					vpeB
 *	@param value					l
 *	@throw std::invalid_argument	ɓ̃vpeB݂ƂX[
 */
void CEnumImpl::AddProperty(const OLECHAR* pwszName, long value) {
	assert(pwszName != 0);

	static DISPID	id = 100;
	wchar_t*		pwsz = m_bIgnoreCase ? new wchar_t[wcslen(pwszName) + 1] : const_cast<OLECHAR*>(pwszName);

	if(m_bIgnoreCase) {
		wcscpy(pwsz, pwszName);
		::CharLowerW(pwsz);
	}
	const NameToIdTable::const_iterator	it = m_mapNameTable.find(pwsz);
	if(it != m_mapNameTable.end())
		throw std::invalid_argument("There is already property has specified name.");
	m_mapNameTable[pwsz] = id;
	m_mapIdTable[id++] = value;
	if(m_bIgnoreCase)
		delete[] pwsz;
}

///	IDispatch::GetTypeInfo
STDMETHODIMP CEnumImpl::GetTypeInfo(UINT iTypeInfo, LCID lcid, ITypeInfo** ppTypeInfo) {
	VERIFY_POINTER(ppTypeInfo);
	*ppTypeInfo = 0;
	return E_NOTIMPL;
}

///	IDispatch::GetTypeInfoCount
STDMETHODIMP CEnumImpl::GetTypeInfoCount(UINT* pcTypeInfo) {
	VERIFY_POINTER(pcTypeInfo);
	*pcTypeInfo = 0;
	return S_OK;
}

///	IDispatch::GetIDsOfNames
STDMETHODIMP CEnumImpl::GetIDsOfNames(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId) {
	VERIFY_POINTER(rgDispId);
	if(riid != IID_NULL || rgszNames == 0)
		return E_INVALIDARG;

	wchar_t*	pwsz = m_bIgnoreCase ? new wchar_t[wcslen(rgszNames[0]) + 1] : rgszNames[0];

	if(m_bIgnoreCase) {
		wcscpy(pwsz, rgszNames[0]);
		::CharLowerW(pwsz);
	}
	NameToIdTable::const_iterator it = m_mapNameTable.find(pwsz);
	if(m_bIgnoreCase)
		delete[] pwsz;
	if(it == m_mapNameTable.end())
		return DISP_E_UNKNOWNNAME;
	rgDispId[0] = it->second;
	return S_OK;
}

///	IDispatch::Invoke
STDMETHODIMP CEnumImpl::Invoke(DISPID dispidMember, REFIID riid, LCID lcid,
		WORD wFlags, DISPPARAMS *pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr) {
	if(riid != IID_NULL)
		return E_INVALIDARG;
	else if(pVarResult == 0)
		return S_OK;
	else if((wFlags & DISPATCH_PROPERTYGET) == 0)
		return DISP_E_MEMBERNOTFOUND;

	const IdToValueTable::const_iterator	it = m_mapIdTable.find(dispidMember);
	if(it == m_mapIdTable.end())
		return DISP_E_MEMBERNOTFOUND;

	pVarResult->vt = VT_I4;
	pVarResult->lVal = it->second;
	return S_OK;
}

/* [EOF] */